#ifndef WRITERS_GTXLWRITER_H
#define WRITERS_GTXLWRITER_H

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include "gts.h"

namespace algorithms {



namespace writers {

using namespace data_structures;

class GTXLWRITER : public ALGORITHM 
{

public:
    GTXLWRITER();

    ~GTXLWRITER();
    
    void initialize(char *filename);
    
    void run(GTS &GraphGrammar);
    
private:

    xmlDocPtr doc;
    
    char *filename;
    
    void WriteHypergraph(xmlNodePtr node, HYPERGRAPH &hg);

   //timur
    void WriteRuleGuard(xmlNodePtr &node, string exp);
    
   
};

};
};

using namespace algorithms;
using namespace algorithms::writers;

#endif
