/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef ALGORITHM_APPROXIMATED_UNFOLDING_H
#define ALGORITHM_APPROXIMATED_UNFOLDING_H

#include "algorithm.h"

namespace algorithms
{
   namespace petrigraph
   {
      class APPROXIMATED_UNFOLDING: public ALGORITHM
      {
       public:
         APPROXIMATED_UNFOLDING();
	 virtual ~APPROXIMATED_UNFOLDING();
	 
	 virtual void initialize(GTS* i_grammar, ALGORITHM* i_gxlwriter);
	 virtual void run(PETRIGRAPH* pg);
      
       protected:
         GTS* grammar;
	 ALGORITHM* gxlwriter;
      };
   };
};
using namespace algorithms;
using namespace algorithms::petrigraph;

#endif
