/***************************************************************************
 *   Copyright (C) 2006 by root                                            *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef BWRA_H
#define BWRA_H

#include "algorithm.h"
#include "ptnet.h"
#include "marking.h"

namespace algorithms
{

namespace ptnet
{

class BWRA: public ALGORITHM
{

public:

    BWRA();

    ~BWRA();

    // virtual
    virtual void initialize(PTNET * i_ptnet);
    // virtual
    virtual bool run(list<MARKING> m, char * tracefile);

    // virtual
    virtual bool run(MARKING m, long * psize);

private:

   PTNET * m_p_ptnet;

};

};

};

using namespace algorithms;
using namespace ptnet;

#endif
