/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EXPRESSION_ENGINE_PN_H
#define EXPRESSION_ENGINE_PN_H

#include "expression_engine.h"

namespace attributes {

class EXPRESSION_ENGINE_PN: public EXPRESSION_ENGINE
{
public:
    EXPRESSION_ENGINE_PN();

    ~EXPRESSION_ENGINE_PN();

	virtual void evaluate(ExpressionElement & e);
	
	virtual string run(ExpressionElement &e, PRINT_TYPE type);

	virtual bool refine();

	virtual bool smallereq(ExpressionElement ee1, ExpressionElement ee2);

protected:

	int numberN;

	virtual vector<ExpressionElement> GetPossibleValues(T type);

};

};

#endif
