/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "logicreader.h"

#include <fstream>

extern "C" int lp_parse();
extern "C" int lp_debug;
// extern "C" int lp__flex_debug;
extern Node *lp_startNode;

namespace algorithms {

namespace readers {

namespace logic_reader {
  fstream is;
}

LOGICREADER::LOGICREADER()
{
}


LOGICREADER::~LOGICREADER()
{
}

void LOGICREADER::initialize(const char *filename)
{
  file = filename;
}
    
void LOGICREADER::run(Node **formula)
{
  logic_reader::is.open(file.c_str(), ios::in);
  lp_debug = 0;
//  lp__flex_debug = 0;
  lp_parse ();
  *formula = lp_startNode->copy();
  logic_reader::is.close();
}

};

};
