/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "markingsreader.h"

#include <fstream>

extern "C" int mp_parse();
extern "C" int mp_debug;
// extern "C" int mp__flex_debug;
extern Node *mp_startNode;

namespace algorithms {

namespace readers {

namespace markings_reader {
  fstream is;
}

MARKINGSREADER::MARKINGSREADER()
{
}


MARKINGSREADER::~MARKINGSREADER()
{
}

void MARKINGSREADER::initialize(const char *filename)
{
  file = filename;
}
    
void MARKINGSREADER::run(Node **formula)
{
  markings_reader::is.open(file.c_str(), ios::in);
  mp_debug = 0;
//  mp__flex_debug = 0;
  mp_parse ();
  *formula = mp_startNode->copy();
  markings_reader::is.close();
}

};

};
