
#include <iostream>
#include <string.h>
#include "helpfunction.h"

#define MAX 15


using namespace std;

/* 
char *catstrint(char* strvalue, int intvalue)
char* + int -> char*
*/
char *catstrint(char* strvalue, int intvalue)
{
   char *strcounter=new char[MAX];
   sprintf(strcounter,"%d\0",intvalue);
   
   int length_1 = strlen(strvalue);
   int length_2 = strlen(strcounter);

   char *returnstring=new char[length_1+length_2+1];
   strcpy(returnstring, strvalue);
   strcat(returnstring, strcounter);

   return returnstring;
}



/*
char *catintstr(int intvalue, char* strvalue)
int + char* -> char*
*/
char *catintstr(int intvalue, char* strvalue)
{
   char *strcounter=new char[MAX];
   sprintf(strcounter,"%d\0",intvalue);

   int length_1 = strlen(strvalue);
   int length_2 = strlen(strcounter);

   char *returnstring=new char[length_1+length_2+1];
   strcpy(returnstring, strcounter);
   strcat(returnstring, strvalue);

   return returnstring;
}



/*
char *catstrstr(char *first, const char *second)
const char* + const char* -> char*
*/
char *catstrstr(const char *first, const char *second)
{
   int length_1 = strlen(first);
   int length_2 = strlen(second);
   
   char *returnstring=new char[length_1+length_2+1];;
   strcpy(returnstring, first);
   strcat(returnstring, second);
   return returnstring;
}



/*
void printcharlist(list <char*> charlist)
*/
void printcharlist(list <char*> charlist)
{
   for (list<char*>::iterator itr=charlist.begin(); itr != charlist.end(); itr++) {
      if (itr != (--charlist.end()))
         cout <<*itr <<".";
      else
         cout <<*itr;
   }
}


/*
int pathcmp(const list<char*> first, const list<char*> second)
*/
int pathcmp(const list<char*> first, const list<char*> second)
{
   int size_first=first.size();
   int size_second=second.size();
   if (size_first==size_second) {
      list<char*>::const_iterator itr_first=first.begin();
      list<char*>::const_iterator itr_second=second.begin();
      while (itr_first != first.end()) {
         if (strcmp(*itr_first, *itr_second)==0) {
            itr_first++;
            itr_second++;
         }
         else
            return -1;
      }
      return 0;
   }
   return -1;
}


/*
char* charlisttochar(list <char*> charlist)
*/
char* charlisttochar(list <char*> charlist)
{
   char *list_="";
   for (list<char*>::iterator itr=charlist.begin(); itr != charlist.end(); itr++) {
      list_=catstrstr(list_, *itr);
   }
   return list_;
}



