/***************************************************************************
 *   Copyright (C) 2007 by Salil Joshi   *
 *   hellfeuer@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DATA_STRUCTURESMARKING_H
#define DATA_STRUCTURESMARKING_H
#include <vector>
using std::vector;

namespace semilin {

/**
	@author hellfeuer <hellfeuer@gmail.com>
*/

/*Represents a marking. basically a vector, but with the requierd operations*/
class slmarking{
	private:
		vector<unsigned int> m;
public:
	slmarking();
	slmarking(unsigned int n);
	slmarking (const slmarking& a);
    slmarking* operator+(const slmarking & a);
    void operator+=(const slmarking & a);
    unsigned int& operator[](unsigned int i);
    bool operator==(slmarking &a);
    bool operator<(const slmarking & a);
    void print();
    bool isZero();
    
    unsigned int getN();
    ~slmarking();

};

};

using namespace semilin;

#endif
