/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PLUS = 258,
     MINUS = 259,
     MULT = 260,
     DIV = 261,
     ASGN = 262,
     LEFT = 263,
     RIGHT = 264,
     SEPARATOR = 265,
     COMMA = 266,
     COLON = 267,
     EQ = 268,
     LT = 269,
     GT = 270,
     LE = 271,
     GE = 272,
     NE = 273,
     TRUE = 274,
     FALSE = 275,
     NOT = 276,
     AND = 277,
     OR = 278,
     ISNULL = 279,
     IF = 280,
     THEN = 281,
     ELSE = 282,
     FI = 283,
     WHILE = 284,
     DO = 285,
     OD = 286,
     TO = 287,
     NEW = 288,
     DELETE = 289,
     NULLPOINTER = 290,
     VAR = 291,
     TYPE = 292,
     IS = 293,
     STR_CONST = 294,
     SKIP = 295,
     ID = 296,
     INT_CONST = 297,
     INTEGER = 298,
     STRING = 299,
     POINTER = 300,
     RECORD = 301,
     MOD = 302,
     UMINUS = 303
   };
#endif
/* Tokens.  */
#define PLUS 258
#define MINUS 259
#define MULT 260
#define DIV 261
#define ASGN 262
#define LEFT 263
#define RIGHT 264
#define SEPARATOR 265
#define COMMA 266
#define COLON 267
#define EQ 268
#define LT 269
#define GT 270
#define LE 271
#define GE 272
#define NE 273
#define TRUE 274
#define FALSE 275
#define NOT 276
#define AND 277
#define OR 278
#define ISNULL 279
#define IF 280
#define THEN 281
#define ELSE 282
#define FI 283
#define WHILE 284
#define DO 285
#define OD 286
#define TO 287
#define NEW 288
#define DELETE 289
#define NULLPOINTER 290
#define VAR 291
#define TYPE 292
#define IS 293
#define STR_CONST 294
#define SKIP 295
#define ID 296
#define INT_CONST 297
#define INTEGER 298
#define STRING 299
#define POINTER 300
#define RECORD 301
#define MOD 302
#define UMINUS 303




/* Copy the first part of user declarations.  */
#line 1 "parser.y"

#include <malloc.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../pointer_lang/abstree.h"
#include "../pointer_lang/symboltable.h"

extern int yylex();
extern int yydebug;


extern int row;

extern "C"
{
   int yywrap(){
       return 1; 
   }
   extern int yyparse();
   extern void cleanup() {
      fprintf(stderr, "syntax error in line %d\n",row);	
      fprintf(stderr, "Program will be aborted\n");
      exit(1);
   }
   extern void yyerror(const char* s)
   {
      //fprintf(stderr, "%s\n", s);
   }
}
NODE *abstree;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 66 "parser.y"
typedef union YYSTYPE {
   int  integer ;
   char*  string;
   char name[MAX_ID];
   NODE* Node;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 222 "parser.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 234 "parser.tab.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   169

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  51
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  17
/* YYNRULES -- Number of rules. */
#define YYNRULES  58
/* YYNRULES -- Number of states. */
#define YYNSTATES  125

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   303

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    14,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    13,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     6,     8,    12,    13,    18,    27,    30,
      34,    38,    39,    41,    43,    48,    52,    53,    57,    58,
      60,    64,    68,    73,    78,    83,    88,    96,   102,   104,
     106,   108,   112,   116,   120,   124,   128,   132,   136,   140,
     143,   147,   149,   151,   153,   157,   161,   165,   169,   173,
     176,   178,   182,   186,   190,   192,   195,   197,   199
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      52,     0,    -1,    53,    58,    -1,     1,    -1,    54,    10,
      53,    -1,    -1,    38,    43,    12,    57,    -1,    39,    43,
      40,    48,     8,    55,    56,     9,    -1,    39,    43,    -1,
      43,    12,    57,    -1,    11,    55,    56,    -1,    -1,    45,
      -1,    46,    -1,    47,    34,    48,    43,    -1,    61,    10,
      59,    -1,    -1,    61,    10,    59,    -1,    -1,    43,    -1,
      60,     7,    63,    -1,    64,     7,    63,    -1,    35,     8,
      60,     9,    -1,    35,     8,    64,     9,    -1,    36,     8,
      60,     9,    -1,    36,     8,    64,     9,    -1,    27,    62,
      28,    58,    29,    58,    30,    -1,    31,    62,    32,    58,
      33,    -1,    42,    -1,    21,    -1,    22,    -1,    63,    15,
      63,    -1,    63,    16,    63,    -1,    63,    17,    63,    -1,
      63,    18,    63,    -1,    63,    19,    63,    -1,    63,    20,
      63,    -1,    62,    24,    62,    -1,    62,    25,    62,    -1,
      23,    62,    -1,     8,    62,     9,    -1,    67,    -1,    43,
      -1,    64,    -1,    63,     3,    63,    -1,    63,     4,    63,
      -1,    63,     5,    63,    -1,    63,     6,    63,    -1,    63,
      49,    63,    -1,     4,    63,    -1,    37,    -1,     8,    63,
       9,    -1,    66,    14,    65,    -1,    66,    14,    65,    -1,
      43,    -1,    43,    13,    -1,    43,    -1,    44,    -1,    41,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    78,    78,    86,    89,    97,   100,   110,   119,   128,
     139,   147,   150,   155,   161,   170,   177,   180,   187,   190,
     201,   209,   217,   224,   231,   238,   245,   254,   262,   269,
     274,   279,   287,   295,   303,   311,   319,   327,   357,   387,
     405,   408,   409,   416,   417,   433,   451,   468,   484,   500,
     510,   515,   518,   528,   538,   548,   558,   568,   574
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PLUS", "MINUS", "MULT", "DIV", "ASGN",
  "LEFT", "RIGHT", "SEPARATOR", "COMMA", "COLON", "'^'", "'.'", "EQ", "LT",
  "GT", "LE", "GE", "NE", "TRUE", "FALSE", "NOT", "AND", "OR", "ISNULL",
  "IF", "THEN", "ELSE", "FI", "WHILE", "DO", "OD", "TO", "NEW", "DELETE",
  "NULLPOINTER", "VAR", "TYPE", "IS", "STR_CONST", "SKIP", "ID",
  "INT_CONST", "INTEGER", "STRING", "POINTER", "RECORD", "MOD", "UMINUS",
  "$accept", "program", "decl", "vdecl", "tvdecl", "tdecllist", "type",
  "statements", "statementsA", "ACTION", "stm", "bexp", "exp", "path",
  "last", "first", "const", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    94,    46,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    51,    52,    52,    53,    53,    54,    54,    54,    55,
      56,    56,    57,    57,    57,    58,    58,    59,    59,    60,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    63,    63,    63,    63,    63,    63,    63,    63,    63,
      63,    63,    64,    65,    66,    66,    65,    67,    67
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     1,     3,     0,     4,     8,     2,     3,
       3,     0,     1,     1,     4,     3,     0,     3,     0,     1,
       3,     3,     4,     4,     4,     4,     7,     5,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     1,     1,     1,     3,     3,     3,     3,     3,     2,
       1,     3,     3,     3,     1,     2,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     3,     0,     0,     0,    16,     0,     0,     8,     1,
       0,     0,     0,     0,    28,    19,     2,     0,     0,     0,
       0,     5,     0,     0,     0,     0,    29,    30,     0,    50,
      58,    42,    57,     0,     0,    43,    41,     0,     0,     0,
      55,     0,    18,     0,     0,     4,    12,    13,     0,     6,
       0,     0,    49,     0,     0,    39,     0,     0,    16,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,     0,     0,     0,     0,    20,    15,     0,    21,    56,
      52,     0,     0,     0,     0,    40,    51,    37,    38,     0,
      44,    45,    46,    47,    31,    32,    33,    34,    35,    36,
      48,     0,    22,    23,    24,    25,    18,     0,     0,     0,
      11,    16,    27,    17,    53,    14,     0,     0,     0,     0,
       9,    11,     7,    26,    10
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     4,     5,     6,   110,   118,    49,    16,    76,    17,
      18,    33,    34,    35,    80,    20,    36
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -56
static const short int yypact[] =
{
      96,   -56,   -21,    -7,    49,    36,    41,    50,     5,   -56,
     120,   120,    60,    65,   -56,    46,   -56,    67,    78,    84,
      80,    42,    40,    51,   125,   120,   -56,   -56,   120,   -56,
     -56,    46,   -56,    18,     8,   -56,   -56,    23,    55,    55,
     -56,   125,    36,   125,    57,   -56,   -56,   -56,    58,   -56,
      94,   125,   -56,    45,     1,   -56,   120,   120,    36,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
      36,    95,    98,    99,   100,    35,   -56,   112,    35,    46,
     -56,    91,    62,    82,    26,   -56,   -56,   -56,   102,   101,
       3,     3,   -56,   -56,    35,    35,    35,    35,    35,    35,
     -56,   103,   -56,   -56,   -56,   -56,    36,    57,    97,   132,
     126,    36,   -56,   -56,   -56,   -56,    40,    82,   136,   116,
     -56,   126,   -56,   -56,   -56
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -56,   -56,   127,   -56,    30,    28,    34,   -55,    47,    44,
     -40,    33,    52,    -5,    48,   -43,   -56
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -55
static const yysigned_char yytable[] =
{
      19,    81,    77,    89,    59,    60,    61,    62,    61,    62,
      86,    59,    60,    61,    62,   101,    63,    64,    65,    66,
      67,    68,     7,    63,    64,    65,    66,    67,    68,    59,
      60,    61,    62,    72,    74,    86,     8,    19,    59,    60,
      61,    62,    56,    57,    37,    23,    58,    56,    57,     9,
      69,    21,    69,    19,    85,    70,   119,    69,    53,    40,
     -54,    55,    22,    10,    81,    19,    77,    11,    38,    56,
      57,    12,    13,    39,    41,    69,    52,    54,    14,    15,
       2,     3,    71,    73,    69,    46,    47,    48,    42,    87,
      88,    43,    82,    75,    44,    78,    -5,     1,    15,    50,
      79,    19,    83,    84,   102,   107,    19,   103,   104,   105,
     108,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   106,    -5,    24,   109,    56,    -5,    25,    24,
     111,    -5,    -5,    51,     2,     3,   112,   117,    -5,    -5,
     115,    26,    27,    28,   116,   122,   123,   121,    45,   124,
     120,     0,     0,   113,     0,   114,     0,    29,     0,     0,
       0,    30,    29,    31,    32,     0,    30,     0,    31,    32
};

static const yysigned_char yycheck[] =
{
       5,    44,    42,    58,     3,     4,     5,     6,     5,     6,
       9,     3,     4,     5,     6,    70,    15,    16,    17,    18,
      19,    20,    43,    15,    16,    17,    18,    19,    20,     3,
       4,     5,     6,    38,    39,     9,    43,    42,     3,     4,
       5,     6,    24,    25,    11,    40,    28,    24,    25,     0,
      49,    10,    49,    58,     9,    32,   111,    49,    25,    13,
      14,    28,    12,    27,   107,    70,   106,    31,     8,    24,
      25,    35,    36,     8,     7,    49,    24,    25,    42,    43,
      38,    39,    38,    39,    49,    45,    46,    47,    10,    56,
      57,     7,    34,    41,    14,    43,     0,     1,    43,    48,
      43,   106,     8,    51,     9,    14,   111,     9,     9,     9,
      48,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    10,    27,     4,    43,    24,    31,     8,     4,
      29,    35,    36,     8,    38,    39,    33,    11,    42,    43,
      43,    21,    22,    23,    12,     9,    30,   117,    21,   121,
     116,    -1,    -1,   106,    -1,   107,    -1,    37,    -1,    -1,
      -1,    41,    37,    43,    44,    -1,    41,    -1,    43,    44
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,    38,    39,    52,    53,    54,    43,    43,     0,
      27,    31,    35,    36,    42,    43,    58,    60,    61,    64,
      66,    10,    12,    40,     4,     8,    21,    22,    23,    37,
      41,    43,    44,    62,    63,    64,    67,    62,     8,     8,
      13,     7,    10,     7,    14,    53,    45,    46,    47,    57,
      48,     8,    63,    62,    63,    62,    24,    25,    28,     3,
       4,     5,     6,    15,    16,    17,    18,    19,    20,    49,
      32,    60,    64,    60,    64,    63,    59,    61,    63,    43,
      65,    66,    34,     8,    63,     9,     9,    62,    62,    58,
      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
      63,    58,     9,     9,     9,     9,    10,    14,    48,    43,
      55,    29,    33,    59,    65,    43,    12,    11,    56,    58,
      57,    55,     9,    30,    56
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 78 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type = T_PROGRAM;
			(yyval.Node)->pointer=(PROGRAM*)malloc(sizeof(PROGRAM));
			((PROGRAM*)(yyval.Node)->pointer)->declarations=(yyvsp[-1].Node);
			((PROGRAM*)(yyval.Node)->pointer)->body=(yyvsp[0].Node);
			abstree=(yyval.Node);
		;}
    break;

  case 3:
#line 86 "parser.y"
    {cleanup();;}
    break;

  case 4:
#line 89 "parser.y"
    {
			
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_DECLLIST;
			(yyval.Node)->pointer=(DECLLIST*)malloc(sizeof(DECLLIST));
			((DECLLIST*)(yyval.Node)->pointer)->head=(yyvsp[-2].Node);
			((DECLLIST*)(yyval.Node)->pointer)->tail=(yyvsp[0].Node);
		;}
    break;

  case 5:
#line 97 "parser.y"
    {(yyval.Node)=NULL;;}
    break;

  case 6:
#line 100 "parser.y"
    {

			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type=T_VARDECL;
			(yyval.Node)->pointer=(VARDECL*)malloc(sizeof(VARDECL));
			strcpy(((VARDECL*)(yyval.Node)->pointer)->name,(yyvsp[-2].name));	
			((VARDECL*)(yyval.Node)->pointer)->type=(yyvsp[0].Node);
			((VARDECL*)(yyval.Node)->pointer)->programcounter=row;
			
		;}
    break;

  case 7:
#line 110 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type=T_TYPEDECL;
			(yyval.Node)->pointer=(TYPEDECL*)malloc(sizeof(TYPEDECL));
			((TYPEDECL*)(yyval.Node)->pointer)->head=(yyvsp[-2].Node);
			((TYPEDECL*)(yyval.Node)->pointer)->tail=(yyvsp[-1].Node);
			strcpy(((TYPEDECL*)(yyval.Node)->pointer)->name,(yyvsp[-6].name));
			((TYPEDECL*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 8:
#line 119 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type=T_TYPEDECLNULL;
			(yyval.Node)->pointer=(TYPEDECLNULL*)malloc(sizeof(TYPEDECLNULL));
		        strcpy(((TYPEDECL*)(yyval.Node)->pointer)->name,(yyvsp[0].name));
			((TYPEDECL*)(yyval.Node)->pointer)->programcounter=row;	
		;}
    break;

  case 9:
#line 128 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type=T_TVARDECL;
			(yyval.Node)->pointer=NULL;
			(yyval.Node)->pointer=(TVARDECL*)malloc(sizeof(TVARDECL));
			strcpy(((TVARDECL*)(yyval.Node)->pointer)->name,(yyvsp[-2].name));	
			((TVARDECL*)(yyval.Node)->pointer)->type=(yyvsp[0].Node);
			((TVARDECL*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 10:
#line 139 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type=T_TYPEDECLLIST;
			(yyval.Node)->pointer=(TYPEDECLLIST*)malloc(sizeof(TYPEDECLLIST));
			((TYPEDECLLIST*)(yyval.Node)->pointer)->head=(yyvsp[-1].Node);
			((TYPEDECLLIST*)(yyval.Node)->pointer)->tail=(yyvsp[0].Node);
			((TYPEDECLLIST*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 11:
#line 147 "parser.y"
    {(yyval.Node)=NULL;;}
    break;

  case 12:
#line 150 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_INTEGER;
			(yyval.Node)->pointer = NULL;	
		;}
    break;

  case 13:
#line 155 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_STRING;
			(yyval.Node)->pointer = NULL;
		;}
    break;

  case 14:
#line 161 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_PTOREC;
			(yyval.Node)->pointer = (PTOREC*)malloc(sizeof(PTOREC));
			strcpy(((PTOREC*)(yyval.Node)->pointer)->name,(yyvsp[0].name));
			((PTOREC*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 15:
#line 170 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_STMLIST;
			(yyval.Node)->pointer=(STMLIST*)malloc(sizeof(STMLIST));
			((STMLIST*)(yyval.Node)->pointer)->head=(yyvsp[-2].Node);
			((STMLIST*)(yyval.Node)->pointer)->tail=(yyvsp[0].Node);
		;}
    break;

  case 16:
#line 177 "parser.y"
    {(yyval.Node)=NULL;;}
    break;

  case 17:
#line 180 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_STMLIST;
			(yyval.Node)->pointer=(STMLIST*)malloc(sizeof(STMLIST));
			((STMLIST*)(yyval.Node)->pointer)->head=(yyvsp[-2].Node);
			((STMLIST*)(yyval.Node)->pointer)->tail=(yyvsp[0].Node);
		;}
    break;

  case 18:
#line 187 "parser.y"
    {(yyval.Node)=NULL;;}
    break;

  case 19:
#line 190 "parser.y"
    {	
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type = T_IDENTIFIER;
			(yyval.Node)->pointer=(IDENTIFIER*)malloc(sizeof(IDENTIFIER));
			strcpy(((IDENTIFIER*)(yyval.Node)->pointer)->name,(yyvsp[0].name));	
			((IDENTIFIER*)(yyval.Node)->pointer)->symboltableentry=NULL;
			((IDENTIFIER*)(yyval.Node)->pointer)->programcounter=row;

		;}
    break;

  case 20:
#line 201 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_ASSIGNER;
			(yyval.Node)->pointer=(ASSIGNER*)malloc(sizeof(ASSIGNER));
			((ASSIGNER*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			((ASSIGNER*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			((ASSIGNER*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 21:
#line 209 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_ASSIGNER;
			(yyval.Node)->pointer=(ASSIGNER*)malloc(sizeof(ASSIGNER));
			((ASSIGNER*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			((ASSIGNER*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			((ASSIGNER*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 22:
#line 217 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_NEW;
			(yyval.Node)->pointer=(ALLOC*)malloc(sizeof(ALLOC));
			((ALLOC*)(yyval.Node)->pointer)->path=(yyvsp[-1].Node);
			((ALLOC*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 23:
#line 224 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_NEW;
			(yyval.Node)->pointer=(ALLOC*)malloc(sizeof(ALLOC));
			((ALLOC*)(yyval.Node)->pointer)->path=(yyvsp[-1].Node);
			((ALLOC*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 24:
#line 231 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_DELETE;
			(yyval.Node)->pointer=(DELETE_*)malloc(sizeof(DELETE_));
			((DELETE_*)(yyval.Node)->pointer)->path=(yyvsp[-1].Node);
			((DELETE_*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 25:
#line 238 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_DELETE;
			(yyval.Node)->pointer=(DELETE_*)malloc(sizeof(DELETE_));
			((DELETE_*)(yyval.Node)->pointer)->path=(yyvsp[-1].Node);
			((DELETE_*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 26:
#line 245 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_IFSTM;
			(yyval.Node)->pointer=(IFSTM*)malloc(sizeof(IFSTM));
			((IFSTM*)(yyval.Node)->pointer)->bexp=(yyvsp[-5].Node);
			((IFSTM*)(yyval.Node)->pointer)->ifstm=(yyvsp[-3].Node);
			((IFSTM*)(yyval.Node)->pointer)->elsestm=(yyvsp[-1].Node);
			((IFSTM*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 27:
#line 254 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_WHILE;
			(yyval.Node)->pointer=(WHILESTM*)malloc(sizeof(WHILESTM));
			((WHILESTM*)(yyval.Node)->pointer)->bexp=(yyvsp[-3].Node);
			((WHILESTM*)(yyval.Node)->pointer)->dostm=(yyvsp[-1].Node);
		        ((WHILESTM*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 28:
#line 262 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_SKIP;
			(yyval.Node)->pointer=NULL;
		;}
    break;

  case 29:
#line 269 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_TRUE;
			(yyval.Node)->pointer=NULL;
		;}
    break;

  case 30:
#line 274 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_FALSE;
			(yyval.Node)->pointer=NULL;
		;}
    break;

  case 31:
#line 279 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_EQUAL;
			(yyval.Node)->pointer=(EQUAL*)malloc(sizeof(EQUAL));
			((EQUAL*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			((EQUAL*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
		        ((EQUAL*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 32:
#line 287 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_SMALLER;
			(yyval.Node)->pointer=(SMALLER*)malloc(sizeof(SMALLER));
			((SMALLER*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			((SMALLER*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			((SMALLER*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 33:
#line 295 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_GREATER;
			(yyval.Node)->pointer=(GREATER*)malloc(sizeof(GREATER));
			((GREATER*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			((GREATER*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			((GREATER*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 34:
#line 303 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_SMALLEREQUAL;
			(yyval.Node)->pointer=(SMALLEREQUAL*)malloc(sizeof(SMALLEREQUAL));
			((SMALLEREQUAL*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			((SMALLEREQUAL*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			((SMALLEREQUAL*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 35:
#line 311 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_GREATEREQUAL;
			(yyval.Node)->pointer=(GREATEREQUAL*)malloc(sizeof(GREATEREQUAL));
			((GREATEREQUAL*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			((GREATEREQUAL*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			((GREATEREQUAL*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 36:
#line 319 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_NOTEQUAL;
			(yyval.Node)->pointer=(NOTEQUAL*)malloc(sizeof(NOTEQUAL));
			((NOTEQUAL*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			((NOTEQUAL*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			((NOTEQUAL*)(yyval.Node)->pointer)->programcounter=row;	
		;}
    break;

  case 37:
#line 327 "parser.y"
    {
                        if ((yyvsp[-2].Node)->type==T_FALSE || (yyvsp[0].Node)->type==T_FALSE) {
			   (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			   (yyval.Node)->type=T_FALSE;
               		   (yyval.Node)->pointer=NULL;
		           free((yyvsp[-2].Node));free((yyvsp[0].Node));
                        }
                        else if ((yyvsp[-2].Node)->type==T_TRUE && (yyvsp[0].Node)->type==T_TRUE) {
			   (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			   (yyval.Node)->type=T_TRUE;
			   (yyval.Node)->pointer=NULL;
		           free((yyvsp[-2].Node));free((yyvsp[0].Node));
                        }
                        else if ((yyvsp[-2].Node)->type==T_TRUE) {
                           (yyval.Node)=(yyvsp[0].Node);
                           free((yyvsp[-2].Node));
                        }
                        else if ((yyvsp[0].Node)->type==T_TRUE) {
                           (yyval.Node)=(yyvsp[-2].Node);
                           free((yyvsp[0].Node));
                        }
                        else {
			   (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			   (yyval.Node)->type =T_AND;
			   (yyval.Node)->pointer=(AND_*)malloc(sizeof(AND_));
			   ((AND_*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			   ((AND_*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			   ((AND_*)(yyval.Node)->pointer)->programcounter=row;
                        }
		;}
    break;

  case 38:
#line 357 "parser.y"
    {
                        if ((yyvsp[-2].Node)->type==T_TRUE || (yyvsp[0].Node)->type==T_TRUE) {
			   (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			   (yyval.Node)->type=T_TRUE;
			   (yyval.Node)->pointer=NULL;
		           free((yyvsp[-2].Node));free((yyvsp[0].Node));
                        }
                        else if ((yyvsp[-2].Node)->type==T_FALSE && (yyvsp[0].Node)->type==T_FALSE) {
			   (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			   (yyval.Node)->type=T_FALSE;
			   (yyval.Node)->pointer=NULL;
		           free((yyvsp[-2].Node));free((yyvsp[0].Node));
                        }
                        else if ((yyvsp[-2].Node)->type==T_FALSE) {
                           (yyval.Node)=(yyvsp[0].Node);
                           free((yyvsp[-2].Node));
                        }
                        else if ((yyvsp[0].Node)->type==T_FALSE) {
                           (yyval.Node)=(yyvsp[-2].Node);
                           free((yyvsp[0].Node));
                        }
                        else {
			   (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			   (yyval.Node)->type =T_OR;
			   (yyval.Node)->pointer=(OR_*)malloc(sizeof(OR_));
			   ((OR_*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			   ((OR_*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			   ((OR_*)(yyval.Node)->pointer)->programcounter=row;
                        }
		;}
    break;

  case 39:
#line 387 "parser.y"
    {
                        if ((yyvsp[0].Node)->type==T_TRUE) {
                           (yyvsp[0].Node)->type=T_FALSE;
			   (yyval.Node)=(yyvsp[0].Node);
                        }
                        else if ((yyvsp[0].Node)->type==T_FALSE) {
                           (yyvsp[0].Node)->type=T_TRUE;
			   (yyval.Node)=(yyvsp[0].Node);
                        }
                        else {
			   (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			   (yyval.Node)->type =T_NOT;
			   (yyval.Node)->pointer=(NOT_*)malloc(sizeof(NOT_));
			   ((NOT_*)(yyval.Node)->pointer)->left=(yyvsp[0].Node);
			   ((NOT_*)(yyval.Node)->pointer)->programcounter=row;
                        }

		;}
    break;

  case 40:
#line 405 "parser.y"
    {(yyval.Node)=(yyvsp[-1].Node);;}
    break;

  case 41:
#line 408 "parser.y"
    {(yyval.Node)=(yyvsp[0].Node);;}
    break;

  case 42:
#line 409 "parser.y"
    {	
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type = T_IDENTIFIER;
			(yyval.Node)->pointer=(IDENTIFIER*)malloc(sizeof(IDENTIFIER));
			strcpy(((IDENTIFIER*)(yyval.Node)->pointer)->name,(yyvsp[0].name));
			((IDENTIFIER*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 43:
#line 416 "parser.y"
    { (yyval.Node)=(yyvsp[0].Node);;}
    break;

  case 44:
#line 417 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			if ((yyvsp[-2].Node)->type == T_INTEGERCONST && (yyvsp[0].Node)->type == T_INTEGERCONST) {	
			    (yyval.Node)->type = T_INTEGERCONST;
			    (yyval.Node)->pointer=(INTEGERCONST*)malloc(sizeof(INTEGERCONST));
			    ((INTEGERCONST*)(yyval.Node)->pointer)->value = ((INTEGERCONST*)(yyvsp[-2].Node)->pointer)->value + ((INTEGERCONST*)(yyvsp[0].Node)->pointer)->value;
		            free((yyvsp[-2].Node));free((yyvsp[0].Node));
                        }
			else {
			    (yyval.Node)->type =T_PLUSOP;
			    (yyval.Node)->pointer=(PLUSOP*)malloc(sizeof(PLUSOP));
			    ((PLUSOP*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			    ((PLUSOP*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			    ((PLUSOP*)(yyval.Node)->pointer)->programcounter=row;
			}
		;}
    break;

  case 45:
#line 433 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			if ((yyvsp[-2].Node)->type == T_INTEGERCONST && (yyvsp[0].Node)->type == T_INTEGERCONST) {
			    (yyval.Node)->type = T_INTEGERCONST;
			    (yyval.Node)->pointer=(INTEGERCONST*)malloc(sizeof(INTEGERCONST));
			    ((INTEGERCONST*)(yyval.Node)->pointer)->value = ((INTEGERCONST*)(yyvsp[-2].Node)->pointer)->value - ((INTEGERCONST*)(yyvsp[0].Node)->pointer)->value;
		            free((yyvsp[-2].Node));free((yyvsp[0].Node));
			}
			else {
			   (yyval.Node)->type =T_MINUSOP;
			   (yyval.Node)->pointer=(MINUSOP*)malloc(sizeof(MINUSOP));
			   ((MINUSOP*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			   ((MINUSOP*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			   ((MINUSOP*)(yyval.Node)->pointer)->programcounter=row;
			}	           
			
		
		;}
    break;

  case 46:
#line 451 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			if ((yyvsp[-2].Node)->type == T_INTEGERCONST && (yyvsp[0].Node)->type == T_INTEGERCONST) {	
			    (yyval.Node)->type = T_INTEGERCONST;
			    (yyval.Node)->pointer=(INTEGERCONST*)malloc(sizeof(INTEGERCONST));
			    ((INTEGERCONST*)(yyval.Node)->pointer)->value = ((INTEGERCONST*)(yyvsp[-2].Node)->pointer)->value * ((INTEGERCONST*)(yyvsp[0].Node)->pointer)->value;
		            free((yyvsp[-2].Node));free((yyvsp[0].Node));			   
			}
			else {
			   (yyval.Node)->type =T_MULTOP;
			   (yyval.Node)->pointer=(MULTOP*)malloc(sizeof(MULTOP));
			   ((MULTOP*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			   ((MULTOP*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			   ((MULTOP*)(yyval.Node)->pointer)->programcounter=row;
			}
			
		;}
    break;

  case 47:
#line 468 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			if ((yyvsp[-2].Node)->type == T_INTEGERCONST && (yyvsp[0].Node)->type == T_INTEGERCONST) {
			    (yyval.Node)->type = T_INTEGERCONST;
			    (yyval.Node)->pointer=(INTEGERCONST*)malloc(sizeof(INTEGERCONST));
			    ((INTEGERCONST*)(yyval.Node)->pointer)->value = ((INTEGERCONST*)(yyvsp[-2].Node)->pointer)->value / ((INTEGERCONST*)(yyvsp[0].Node)->pointer)->value;
		            free((yyvsp[-2].Node));free((yyvsp[0].Node));			
			}
			else {
			   (yyval.Node)->type =T_DIVOP;
			   (yyval.Node)->pointer=(DIVOP*)malloc(sizeof(DIVOP));
			   ((DIVOP*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			   ((DIVOP*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			   ((DIVOP*)(yyval.Node)->pointer)->programcounter=row;
			}	
		;}
    break;

  case 48:
#line 484 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			if ((yyvsp[-2].Node)->type == T_INTEGERCONST && (yyvsp[0].Node)->type == T_INTEGERCONST) {
			    (yyval.Node)->type = T_INTEGERCONST;
			    (yyval.Node)->pointer=(INTEGERCONST*)malloc(sizeof(INTEGERCONST));
			    ((INTEGERCONST*)(yyval.Node)->pointer)->value = ((INTEGERCONST*)(yyvsp[-2].Node)->pointer)->value % ((INTEGERCONST*)(yyvsp[0].Node)->pointer)->value;
		            free((yyvsp[-2].Node));free((yyvsp[0].Node));			
			}
			else {
			   (yyval.Node)->type =T_MODOP;
			   (yyval.Node)->pointer=(MODOP*)malloc(sizeof(MODOP));
			   ((MODOP*)(yyval.Node)->pointer)->right=(yyvsp[0].Node);
			   ((MODOP*)(yyval.Node)->pointer)->left=(yyvsp[-2].Node);
			   ((MODOP*)(yyval.Node)->pointer)->programcounter=row;
			}	
		;}
    break;

  case 49:
#line 500 "parser.y"
    {
			  (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			  (yyval.Node)=(NODE*)malloc(sizeof(NODE));
			  (yyval.Node)->type =T_NEGATE;
			  (yyval.Node)->pointer=(NEGATE*)malloc(sizeof(NEGATE));
			  ((NEGATE*)(yyval.Node)->pointer)->expstm=(yyvsp[0].Node);
 			  ((NEGATE*)(yyval.Node)->pointer)->programcounter=row;
			

		;}
    break;

  case 50:
#line 510 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_NULL;
			(yyval.Node)->pointer=NULL;
		;}
    break;

  case 51:
#line 515 "parser.y"
    {(yyval.Node)=(yyvsp[-1].Node);;}
    break;

  case 52:
#line 518 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_PATH;
			(yyval.Node)->pointer=(PATH*)malloc(sizeof(PATH));
			((PATH*)(yyval.Node)->pointer)->last=(yyvsp[0].Node);
			((PATH*)(yyval.Node)->pointer)->first=(yyvsp[-2].Node);
			((PATH*)(yyval.Node)->pointer)->programcounter=row;	
		;}
    break;

  case 53:
#line 528 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type =T_PATH;
			(yyval.Node)->pointer=(PATH*)malloc(sizeof(PATH));
			((PATH*)(yyval.Node)->pointer)->last=(yyvsp[0].Node);
			((PATH*)(yyval.Node)->pointer)->first=(yyvsp[-2].Node);
			((PATH*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 54:
#line 538 "parser.y"
    {	
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type = T_IDENTIFIER;
			(yyval.Node)->pointer=(IDENTIFIER*)malloc(sizeof(IDENTIFIER));
			strcpy(((IDENTIFIER*)(yyval.Node)->pointer)->name,(yyvsp[0].name));	
			((IDENTIFIER*)(yyval.Node)->pointer)->symboltableentry=NULL;
			((IDENTIFIER*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 55:
#line 548 "parser.y"
    {	
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type = T_IDENTIFIER;
			(yyval.Node)->pointer=(IDENTIFIER*)malloc(sizeof(IDENTIFIER));
			strcpy(((IDENTIFIER*)(yyval.Node)->pointer)->name,(yyvsp[-1].name));	
			((IDENTIFIER*)(yyval.Node)->pointer)->symboltableentry=NULL;
			((IDENTIFIER*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 56:
#line 558 "parser.y"
    {	
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->type = T_IDENTIFIER;
			(yyval.Node)->pointer=(IDENTIFIER*)malloc(sizeof(IDENTIFIER));
			strcpy(((IDENTIFIER*)(yyval.Node)->pointer)->name,(yyvsp[0].name));	
			((IDENTIFIER*)(yyval.Node)->pointer)->symboltableentry=NULL;
			((IDENTIFIER*)(yyval.Node)->pointer)->programcounter=row;
		;}
    break;

  case 57:
#line 568 "parser.y"
    { 
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->pointer=(INTEGERCONST*)malloc(sizeof(INTEGERCONST));
			(yyval.Node)->type = T_INTEGERCONST;
			((INTEGERCONST*)(yyval.Node)->pointer)->value = (yyvsp[0].integer);
		;}
    break;

  case 58:
#line 574 "parser.y"
    {
			(yyval.Node)=(NODE*)malloc(sizeof(NODE));
			(yyval.Node)->pointer=(STRCONST*)malloc(sizeof(STRCONST));
			(yyval.Node)->type = T_STRCONST;		
			((STRCONST*)(yyval.Node)->pointer)->value = (yyvsp[0].string);
		;}
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 2029 "parser.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 583 "parser.y"



