/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "testscenario.h"

#include "hypergraph.h"
#include "find_all_matches.h"
#include "find_all_matches_by_sp.h"
#include "findmatch_by_sp.h"
#include "findmatch.h"
#include "costmatrix.h"
#include "searchplan.h"
#include "GTXLReader.h"
#include "gts.h"
#include "approximated_unfolding.h"
#include "gxlwriter.h"
#include "vis_petrinet.h"
#include "pddlwriter.h"
#include "vis_hypergraph.h"
#include "match.h"
#include "bwra.h"
#include "marking.h"


using namespace std;

extern "C"
{
  extern int ttparse();
  extern char *ttstrin;
}

extern vector<ExpressionElement> exprtree;

namespace testspace {

TestScenario::TestScenario()
{
}


TestScenario::~TestScenario()
{
}



void TestScenario::run()
{
// {
// HYPERGRAPH hg;
// VERTEX gv1,gv2;
// EDGE e1,e3, e4, e5, e6;
// 
// gv1.setID( 1 );
// gv2.setID( 3 );
// e1.setID( 2 );
// e1.setLabel( "A" );
// e3.setID( 7 );
// e3.setLabel( "B" );
// 
// e4.setID( 8 );
// e4.setLabel( "B" );
// 
// e5.setID( 9 );
// e5.setLabel( "B" );
// 
// e6.setID( 10 );
// e6.setLabel( "A" );
// 
// hg.addVertex(gv1,gv1.getID());
// hg.addVertex(gv2,gv2.getID());
// 
// list<IDTYPE> el1;
// el1.push_back(1);
// el1.push_back(3);
// hg.addEdge( e1, e1.getID(), el1);
// hg.addEdge( e3, e3.getID(), el1);
// hg.addEdge( e4, e4.getID(), el1);
// hg.addEdge( e5, e5.getID(), el1);
// hg.addEdge( e6, e6.getID(), el1);
// 
// 
// HYPERGRAPH hl;
// VERTEX v1,v2;
// EDGE e2;
// 
// v1.setID( 4 );
// v2.setID( 5 );
// e2.setID( 6 );
// e2.setLabel( "A" );
// 
// hl.addVertex(v1,4);
// hl.addVertex(v2,5);
// 
// list<IDTYPE> el2;
// el2.push_back(4);
// el2.push_back(5);
// hl.addEdge( e2, 6, el2);
// }


// 10.xml good for find all matches

GTXLREADER reader;
reader.initialize("/home/mzaks/SG/files/firewall2.xml");

GTS gts;
reader.run(gts);

HYPERGRAPH hg = *(gts.getStartgraph());

VIS_HYPERGRAPH visHG1;

visHG1.initialize("/home/mzaks/SG/files/ini.ps");
PRINT_TYPE pt = FULL;
visHG1.run(hg, pt);

// HYPERGRAPH hg;
// VERTEX v1,v2,v3,v4;
// v1.setID( 1 );	v2.setID( 2 ); v3.setID( 3 ); v4.setID( 4 );
// hg.addVertex(v1,v1.getID());	hg.addVertex(v2,v2.getID());
// hg.addVertex(v3,v3.getID());	hg.addVertex(v4,v4.getID());
// 
// EDGE e1,e2, e3, e4, e5, e6, e7;
// e1.setLabel( "A" ); e1.setID( 5 );
// list<IDTYPE> el1;
// el1.push_back(1);
// hg.addEdge( e1, e1.getID(), el1);
// 
// e2.setLabel( "B" ); e2.setID( 6 );
// list<IDTYPE> el2;
// el2.push_back(1);
// el2.push_back(2);
// hg.addEdge( e2, e2.getID(), el2);
// 
// e3.setLabel( "B" ); e3.setID( 7 );
// list<IDTYPE> el3;
// el3.push_back(1);
// el3.push_back(2);
// hg.addEdge( e3, e3.getID(), el3);
// 
// e4.setLabel( "B" ); e4.setID( 8 );
// list<IDTYPE> el4;
// el4.push_back(2);
// el4.push_back(3);
// hg.addEdge( e4, e4.getID(), el4);
// 
// e5.setLabel( "A" ); e5.setID( 9 );
// list<IDTYPE> el5;
// el5.push_back(2);
// hg.addEdge( e5, e5.getID(), el5);
// 
// e6.setLabel( "B" ); e6.setID( 10 );
// list<IDTYPE> el6;
// el6.push_back(3);
// el6.push_back(4);
// hg.addEdge( e6, e6.getID(), el6);
// 
// e7.setLabel( "C" ); e7.setID( 11 );
// list<IDTYPE> el7;
// el7.push_back(2);
// el7.push_back(4);
// hg.addEdge( e7, e7.getID(), el7);

// HYPERGRAPH hg;
// VERTEX v1, v2,v3;
// hg.addVertex( v1, 1 ); hg.addVertex( v2, 2 ); hg.addVertex( v3, 3 );
// 
// EDGE e1, e2; e1.setLabel( "A" ); e2.setLabel( "B" );
// list<IDTYPE> el1; el1.push_back(1); el1.push_back(2); hg.addEdge( e1, 4, el1 ); 
// list<IDTYPE> el2; el1.push_back(3); el1.push_back(2); hg.addEdge( e2, 5, el2 );

// COSTMATRIX cm;
// cm.intitialize( &hg );
// cm.run();

map<IDTYPE, RULE>* m = gts.getRules();
map<IDTYPE, RULE>::iterator it = (*m).begin();
// 
// cout << "rileID=" << it->first << endl;
// 
// it++;
HYPERGRAPH lg = *(it->second.getLeft());
VIS_HYPERGRAPH visHG;
// // 
visHG.initialize("/home/mzaks/SG/files/left.ps");
// // 
visHG.run(*(it->second.getLeft()), pt);

// HYPERGRAPH lg;
// VERTEX lv1,lv2,lv3;
// lv1.setID( 1 );	lv2.setID( 2 ); lv3.setID( 3 );
// lg.addVertex(lv1,lv1.getID());
// lg.addVertex(lv2,lv2.getID());
// lg.addVertex(lv3,lv3.getID());
// 
// 
// EDGE le1, le2, le3;
// 
// le1.setLabel( "A" ); le1.setID( 5 );
// list<IDTYPE> lel1;
// lel1.push_back(1);
// lg.addEdge( le1, le1.getID(), lel1);
// 
// le2.setLabel( "B" ); le2.setID( 6 );
// list<IDTYPE> lel2;
// lel2.push_back(1);
// lel2.push_back(2);
// lg.addEdge( le2, le2.getID(), lel2);
// 
// le3.setLabel( "B" ); le3.setID( 7 );
// list<IDTYPE> lel3;
// lel3.push_back(2);
// lel3.push_back(3);
// lg.addEdge( le3, le3.getID(), lel3);

// HYPERGRAPH lg;
// VERTEX lv1, lv2;
// lg.addVertex( lv1, 1 ); lg.addVertex( lv2, 2 );
// 
// EDGE le1, le2; le1.setLabel( "A" ); le2.setLabel( "B" );
// list<IDTYPE> lel1; lel1.push_back(1); lel1.push_back(1); lg.addEdge( le1, 4, lel1 ); 
// list<IDTYPE> lel2; lel1.push_back(1); lel1.push_back(2); lg.addEdge( le2, 5, lel2 );
// 

/*
cout << "Hostgraph" << endl;
cout << "Knoten: " << hg.getVertices().size() << endl;
cout << "Kanten: " << hg.getEdges().size() << endl;

cout << "Mustergraph" << endl;
cout << "Knoten: " << lg.getVertices().size() << endl;
cout << "Kanten: " << lg.getEdges().size() << endl;
cout << endl;
*/

// init_time();
// FINDMATCH_BY_SP fmSP;
// fmSP.initialize( &hg );
// MATCH* mSPl = fmSP.run(&lg,0);
// cout << "FindMatch_by_sp: " << get_time()<< endl;
// 
// cout << *mSPl << endl;


//  SEARCHPLAN searchPlan;
// 
//  searchPlan.initialize( &cm, &lg );
// 
// MATCH* m1 = new MATCH(); 
// MATCH res = searchPlan.startMatching();
// cout << "Result: " << res << endl;



// cout << "Time: " << get_time()<< endl; 
// 
// map<IDTYPE, IDTYPE> matchMap = res.getMatch();
// 
// MATCH res1 = searchPlan.runOperation(m1,0);
// cout << "Result: " << res1 << endl;
// for(map<IDTYPE,IDTYPE>::iterator iter = matchMap.begin(); iter != matchMap.end(); iter++){
// 	MATCH badMatch;
// 	badMatch.setMatch( iter->first, iter->second );
// 	searchPlan.setTestMatch(badMatch);
// 	res = searchPlan.startMatching();
// 	cout << "Result: " << res << endl;
// }







/*init_time();
// list<MATCH> result = searchPlan.startMatchingForAll();
FIND_ALL_MATCHES_BY_SP fasp;
fasp.initialize(&hg);
list<MATCH> result = fasp.run(&lg, NULL, false);
cout << "Time: " << get_time()<< endl;
// for(list<MATCH>::iterator iter = result.begin(); iter != result.end() ; iter ++){
// 
// 	cout << *iter << endl;
// }
cout << "FIND ALL MATCHES By SP: " <<result.size() << endl;*/
// // cout << endl << endl << "findmatch............" << endl;
// // 
// // 


// init_time();
// FINDMATCH fm;
// 
// fm.initialize( &hg );
// MATCH* ml = fm.run(&lg,0);
// cout << "FindMatch: " << get_time()<< endl;
// cout << *ml << endl;
// 
// init_time();
// FIND_ALL_MATCHES fam;
// fam.initialize(&hg);
// result =  fam.run(&lg, NULL, false);
// cout << "Time: " << get_time()<< endl;
// // for(list<MATCH>::iterator iter = result.begin(); iter != result.end() ; iter ++){
// // 
// // 	cout << *iter << endl;
// // }
// cout << "FIND ALL MATCHES: " <<result.size() << endl;

// for(list<MATCH>::iterator iter=ml.begin(); iter!=ml.end(); iter++){
// 	cout << *iter << endl;
// } 

// cout << "hallo" << endl;	














init_time();
APPROXIMATED_UNFOLDING au;
GXLWRITER writer;
au.initialize(&gts, &writer);

PETRIGRAPH pg;

au.run(&pg);
cout << "Time: " << get_time()<< endl;




PTNET pn = (PTNET)pg;

VIS_PETRINET vp;
vp.initialize("/home/mzaks/SG/pn.ps");
vp.run(pn);	

VIS_HYPERGRAPH visHG2;

HYPERGRAPH visHG_g = (HYPERGRAPH)pg;
visHG2.initialize("/home/mzaks/SG/hg.ps");
PRINT_TYPE pt_ = FULL;
visHG2.run(visHG_g, pt_);

set<IDTYPE> sp = pn.getPlaces();

for(set<IDTYPE>::iterator it = sp.begin(); it != sp.end(); it++)
	cout << *it << endl;

PDDLWriter pddl_writer;

BWRA bwra;

bwra.initialize(&pn);
MARKING mar;
TOKEN t1;
t1.setCount(1);
mar.putToken(2210,t1);
// TOKEN t2;
// t2.setCount(1);
// mar.putToken(6247,t2);
// TOKEN t3;
// t3.setCount(1);
// mar.putToken(6235,t3);
// TOKEN t4;
// t4.setCount(1);
// mar.putToken(45461,t4);
long size;
cout <<"Erreichbar " << bwra.run(mar, &size)<< endl;	

pddl_writer.initialize("/home/mzaks/pn");
pddl_writer.run(pn, mar);
}

}


