/***************************************************************************
 *   Copyright (C) 2007 by Valentin Wolf   *
 *   wolf@lahn   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "textreader.h"

namespace algorithms {

namespace readers {
	
TEXTREADER::TEXTREADER()
{
}


TEXTREADER::~TEXTREADER()
{
}

void TEXTREADER::initialize(char *filename)
{
		this->file = filename;
}
 
void TEXTREADER::run(string &sstr)
{
	
	string line,str;

	ifstream is(file);
	if( is.is_open() )
	{
		while( getline(is, line) )
		{
			str=str+line;
		}                       
   
		is.close();
	}  
	else
	{
		cout << "Fehler beim einlesen der Datei!" << endl;
	}
	sstr=str;
	
	
	/*ifstream f;
	string stext;
	//string fileName = "/home/wolf/text.txt";
	f.open(fileName.c_str(), ios::in | ios::binary); // oeffen im Binaer-Modus
	if(file)
	{
		f.seekg(0, ios::end); // zum Ende Datei springen
		long fileSize = f.tellg(); // Dateigroesse auslesen
		f.seekg(0); // Zurueck zum Anfang springen
		char *text = new char[fSize]; // Speicher fuer Text anlegen
		f.read(text, fSize); // Text in 1 Rutsch auslesen
		f.close();
		stext = text;
		delete text; // Speicher aufraeumen 
	}
	else
	{
		cout << "Fehler!";
	}
	*/
	
}

}
}



