#include "token.h"

namespace data_structures
{

TOKEN::TOKEN()
{
 count=0;
}

TOKEN::~ TOKEN()
{
}

const unsigned TOKEN::getCount()
{
    return count;
}

void TOKEN::setCount(unsigned count)
{
    this->count = count;
}

list<EXPRESSION> TOKEN::getAttributes()
{
	return attributes;
}

void TOKEN::setAttributes(list<EXPRESSION> l_exp)
{
	attributes = l_exp;
}

void TOKEN::addAttributes(EXPRESSION exp)
{
	attributes.push_back(exp);
}

ostream& operator<<(ostream& ost, TOKEN& t)
{
	list<EXPRESSION> attributes = t.getAttributes();
	for(list<EXPRESSION>::iterator i = attributes.begin(); i != attributes.end(); i++)
		ost << " " << *i;

	return ost;
}

};


