#ifndef DATA_STRUCTERSTOKEN_H
#define DATA_STRUCTERSTOKEN_H

#include "expression.h"

namespace data_structures
{
class TOKEN
{
public:
	TOKEN();
	~TOKEN();	
	const unsigned getCount();
	void setCount(unsigned count);

	list<EXPRESSION> getAttributes();
	void setAttributes(list<EXPRESSION> l_exp);
	void addAttributes(EXPRESSION exp);

	friend ostream& operator<<(ostream& ost, TOKEN& t);
	
private:
	unsigned count;

	list<EXPRESSION> attributes;
};
};

using namespace data_structures;

#endif







