/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "transition.h"

namespace data_structures
{
   TRANSITION::TRANSITION()
   {
      this->guard = list<EXPRESSION>();
   }

   TRANSITION::~TRANSITION()
   {
   }
   
   TRANSITION TRANSITION::clone()
   {
      TRANSITION t;
      GRAPH_ELEMENT * ge = (GRAPH_ELEMENT *)&t;
      *ge=this->GRAPH_ELEMENT::clone();
      t.guard = this->guard;
      return t;
   }
   
   list<EXPRESSION> TRANSITION::getGuard()
   {
      return this->guard;
   }
   
   void TRANSITION::setGuard(list<EXPRESSION> g)
   {
      this->guard = g;
   }

   void TRANSITION::addGuard(EXPRESSION e)
   {
	this->guard.push_back(e);
   }
};
