/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ALGORITHMSCAUSALITY_RELATION_H
#define ALGORITHMSCAUSALITY_RELATION_H

#include "algorithm.h"
#include "ptnet.h"

namespace algorithms
{
   namespace ptnet
   {
      class CAUSALITY_RELATION: public ALGORITHM
      {
         public:
	    CAUSALITY_RELATION();
	    virtual ~CAUSALITY_RELATION();
	    
	    virtual void initialize(PTNET* i_ptnet);
	    virtual bool run(IDTYPE elem1, IDTYPE elem2);
 
	 protected:
	    PTNET* ptnet;
	    bool in_causality_relation(IDTYPE elem1, IDTYPE elem2, set<IDTYPE>* visited);
      };
   };
};
using namespace algorithms;
using namespace algorithms::ptnet;

#endif
