/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALGORITHMS_MATCHINGS_DATA_STR_SEARCHPLANCOSTTREE_H
#define ALGORITHMS_MATCHINGS_DATA_STR_SEARCHPLANCOSTTREE_H

#include <graph.h>
#include <costgraph.h>

namespace algorithms {

namespace matchings {

namespace data_str_searchplan {

/**
	@author Maxim Zaks
*/
class COSTTREE : public COSTGRAPH
{
public:
    COSTTREE();

    ~COSTTREE();

    void delEdge(IDTYPE eID);
    list<IDTYPE> getFirstCircle();
    list<IDTYPE> getCircle(IDTYPE vID, list<IDTYPE> pfad, map<IDTYPE,int> index);

};

}

}

}

using namespace algorithms::matchings::data_str_searchplan;

#endif
