/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COUNTER_EXAMPLE_READER_H
#define COUNTER_EXAMPLE_READER_H

#include "globals.h"
#include "counter_example.h"

namespace algorithms {

namespace readers {

class COUNTER_EXAMPLE_READER
{

public:

    COUNTER_EXAMPLE_READER();

    ~COUNTER_EXAMPLE_READER();
    
    void initialize(char *filename);
    
    COUNTER_EXAMPLE run();
    
private:

    bool readBinding(BINDING * b, char * ch);

    string fname;

};

}

}

#endif
