/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ID_CHECKER_H
#define ID_CHECKER_H

#include "gts.h"

// This is a help class 
// It takes a rule and gives back a rule with unique ids 

namespace special
{

class ID_CHECKER
{
public:
	ID_CHECKER();

	~ID_CHECKER();

	void initialize(GTS & gts);

	void run(RULE & r);

	void run();

private:

	GTS * gts;

	IDTYPE findMaximum(IDTYPE id, map<IDTYPE, VERTEX> v, map<IDTYPE, EDGE> e);

	bool findVID(IDTYPE id, map<IDTYPE, VERTEX> v);

	bool findEID(IDTYPE id, map<IDTYPE, EDGE> e);

	void checkHypergraph(map<IDTYPE, VERTEX> v, map<IDTYPE, EDGE> e);

};

};

using namespace special;

#endif
