/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MARKING_READER_H
#define MARKING_READER_H

#include "algorithm.h"
#include "marking.h"

#include <list>
#include <sstream>
using namespace std;

namespace algorithms {

namespace readers {

class MARKING_READER: public ALGORITHM
{

public:
    MARKING_READER();

    ~MARKING_READER();

    virtual void initialize(char *filename);

    virtual list<MARKING> run(int type);

private:

    string readFile(const char* file);
    MARKING getMarking(string s);
    void error_exit(const string in);

    char * filename;
};

};

};

#endif
