/***************************************************************************
 *   Copyright (C) 2005 by SZS                                             *
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DATA_STRUCTURESMATCH_H
#define DATA_STRUCTURESMATCH_H
#include "globals.h"

namespace data_structures
{
   class MATCH
   {
      public:
         MATCH();
         ~MATCH();

         MATCH clone();

         void deleteKey(IDTYPE key);
         map<IDTYPE, IDTYPE> getMatch();
         IDTYPE getMatch(IDTYPE key);
         bool hasMatch(IDTYPE key);
         void setMatch(map<IDTYPE, IDTYPE> m);
         void setMatch(IDTYPE key, IDTYPE val);

	 unsigned long count();
	 friend ostream& operator<<(ostream& ost, MATCH& th);
	 friend bool operator==(const MATCH & m1, const MATCH & m2);
    bool IsEqual(const MATCH & m);
	 
      protected:
         map<IDTYPE, IDTYPE> match;
   };
};
using namespace data_structures;

#endif
