/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root@Vitali   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "sponge_call.h"
#include <string>

using namespace std;

namespace scenarios
{

SPONGE_CALL_SCENARIO::SPONGE_CALL_SCENARIO()
{
      this->ID = ALGORITHM_SPONGE_CALL;
      this->name = "sponge_call";
      
      this->inspec.push_back(pair<string, DATA_FORMAT>("hypergraph", GXL));
      this->inspec.push_back(pair<string, DATA_FORMAT>("regular_expression", PLAIN_TEXT));	
      this->outspec.push_back(pair<string, DATA_FORMAT>("marking", PLAIN_TEXT));
      
      this->call_descriptor = "Usage: augur -sc=sponge hypergraph regular_expression marking\n\n\
hypergraph\thypergraph in GXL format\n\
regular_expression\ttested property as regular expression\n\
marking\tmarking corresponding to regular expression\n\n";
}


SPONGE_CALL_SCENARIO::~SPONGE_CALL_SCENARIO()
{
}

void SPONGE_CALL_SCENARIO::run()
{
 string s = "./sponge " + this->filemap["hypergraph"] + " <" + this->filemap["regular_expression"] + " >" + this->filemap["marking"];
 system(s.c_str());
} 

}





