/***************************************************************************
 *   Copyright (C) 2007 by Valentin Wolf   *
 *   wolf@lahn   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MAINSPONGE_H
#define MAINSPONGE_H

#include "common.h"
#include "error.h"
#include "mincover.cc"
#include <iostream>
#include <cstdlib>
#include <cstring>

extern "C"
{
	int spparse(void);
}

extern HYPERGRAPH * spHg;

extern unsigned mode;
extern bool lolaOut;

extern char *spstrin;

int Error::verbosity = 0;

ofstream *of_global;

int main_sponge(HYPERGRAPH * hg, ofstream &of, string str)
{
  	mode = 0;

	lolaOut = false;

	Error::verbosity = 1; // Default: 1

  	spHg = hg;
	of_global=&of;
		/*spstrin = new char[16];
		TESTREADER tr;
		tr.initialize(this->filemap["regular_expression"].c_str());
		string s;
		tr.run(s);
		strcpy(spstrin, s.c_str());*/
	
	spstrin = new char[str.size()];
	strcpy(spstrin, str.c_str()); // to do - read this from the file
	spparse();

	std::cout << std::endl;

	return 0;
}

#endif

