/***************************************************************************
 *   Copyright (C) 2006 
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef EXPRESSION_TABLE
#define EXPRESSION_TABLE

#include "expression.h"
#include "binding.h"

namespace attributes {

  struct TABLE_CELL
   {
	TABLE_CELL()
	{
	 guard_result = true;
	}

	// preset 
	vector<list<EXPRESSION> > preset;

	// postset
	vector<list<EXPRESSION> > postset;

	BINDING binding;

	bool guard_result;
   };

   typedef list<TABLE_CELL> TABLE;

};

#endif
